/* PipelineHelper.h */

/* Copyright (C) 2011-2015  Lucio Carreras
 *
 * This file is part of sayonara player
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */



#ifndef PIPELINEHELPER_H
#define PIPELINEHELPER_H

#include "Helper/Logger/Logger.h"
#include <gst/gst.h>
#include <QVector>

typedef QVector<GstElement*> ElementVector;

namespace PipelineHelper
{

	bool add_elements(GstElement* pipeline, const ElementVector& elements);
	bool add_element(GstElement* pipeline, GstElement* element);

	bool remove_elements(GstElement* pipeline, const ElementVector& elements);
	bool remove_element(GstElement* pipeline, GstElement* element);

	bool link_elements(const ElementVector& elements);

	void apply_state(GstElement* pipeline, const ElementVector& elements);
	void apply_state(GstElement* pipeline, GstElement* element);
}

#endif // PIPELINEHELPER_H
