/* PipelineModifier.h */

/* Copyright (C) 2011-2015  Lucio Carreras
 *
 * This file is part of sayonara player
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */



#ifndef PIPELINEMODIFIER_H
#define PIPELINEMODIFIER_H

#include "ElementOperator.h"
#include <QObject>


class PipelineModifier : public QObject
{
	Q_OBJECT



public:
	enum class Status : quint8 {
		Adding,
		Removing,
		Replacing,
		Finished
	};

signals:
	void sig_finished(PipelineModifier::Status);


private:
	ElementOperator*	_operator;
	GstElement*			_pipeline;
	Status				_status;

public:
	PipelineModifier(GstElement* pipeline);
	~PipelineModifier();

	bool add(GstElement* predecessor, const ElementVector& elems_of_interest, GstElement* successor);
	bool remove(GstElement* predecessor, const ElementVector& elems_of_interest, GstElement* successor);
	bool replace(GstElement* predecessor, GstElement* org_element, GstElement* new_element, GstElement* successor);

	PipelineModifier::Status get_status();

	void set_finished();
};

#endif // PIPELINEMODIFIER_H
