/* LibraryViewDirectories.cpp */

/* Copyright (C) 2011-2015  Lucio Carreras
 *
 * This file is part of sayonara player
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */



#include "LibraryViewDirectories.h"

LibraryViewDirectories::LibraryViewDirectories(QWidget* parent) :
	QTreeView(parent)
{

}

LibraryViewDirectories::~LibraryViewDirectories()
{

}

void LibraryViewDirectories::rc_menu_init() {
	_rc_menu = new ContextMenu(this);
	set_rc_menu(ENTRY_PLAY_NEXT | ENTRY_INFO | ENTRY_DELETE | ENTRY_EDIT | ENTRY_APPEND);
}

void LibraryView::set_rc_menu(int entries){
	if(!_rc_menu) return;
	_rc_menu->setup_entries(entries);
}



void LibraryViewDirectories::rc_menu_show(const QPoint& p) {

	connect(_rc_menu, &ContextMenu::sig_edit_clicked, this, &LibraryViewDirectories::sig_edit_clicked);
	connect(_rc_menu, &ContextMenu::sig_info_clicked, this, &LibraryViewDirectories::sig_info_clicked);
	connect(_rc_menu, &ContextMenu::sig_delete_clicked, this, &LibraryViewDirectories::sig_delete_clicked);
	connect(_rc_menu, &ContextMenu::sig_play_next_clicked, this, &LibraryViewDirectories::sig_play_next_clicked);
	connect(_rc_menu, &ContextMenu::sig_append_clicked, this, &LibraryViewDirectories::sig_append_clicked);

	_rc_menu->exec(p);

	disconnect(_rc_menu, &ContextMenu::sig_edit_clicked, this, &LibraryViewDirectories::sig_edit_clicked);
	disconnect(_rc_menu, &ContextMenu::sig_info_clicked, this, &LibraryViewDirectories::sig_info_clicked);
	disconnect(_rc_menu, &ContextMenu::sig_delete_clicked, this, &LibraryViewDirectories::sig_delete_clicked);
	disconnect(_rc_menu, &ContextMenu::sig_play_next_clicked, this, &LibraryViewDirectories::sig_play_next_clicked);
	disconnect(_rc_menu, &ContextMenu::sig_append_clicked, this, &LibraryViewDirectories::sig_append_clicked);
}
