/* LibraryViewDirectories.h */

/* Copyright (C) 2011-2015  Lucio Carreras
 *
 * This file is part of sayonara player
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */



#ifndef LIBRARYVIEWDIRECTORIES_H
#define LIBRARYVIEWDIRECTORIES_H

#include <QTreeView>
#include <QPoint>
#include "GUI/ContextMenu/ContextMenu.h"

class LibraryViewDirectories : public QTreeView
{
	Q_OBJECT

signals:
	void sig_all_selected();
	void sig_info_clicked();
	void sig_edit_clicked();
	void sig_delete_clicked();
	void sig_play_next_clicked();
	void sig_append_clicked();
	void sig_refresh_clicked();

public:
	LibraryViewDirectories(QWidget* parent=0);
	~LibraryViewDirectories();

protected:
	virtual void rc_menu_init();
	virtual void rc_menu_show(const QPoint& p);

	ContextMenu*	_rc_menu;


};

#endif // LIBRARYVIEWDIRECTORIES_H
